/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Arduino Smart Car Tutorial Lesson 5
 * Tutorial URL http://osoyoo.com/2018/12/19/osoyoo-robot-car-kit-lesson-4-obstacle-avoidance-robot-car/
 * CopyRight www.osoyoo.com

 * This project will show you how to make Osoyoo robot car in auto drive mode and avoid obstacles
 *   
 * 
 */
#include <Servo.h>

#define DELAY_TIME 60   
#define SHORT_DELAY_TIME 45   

#define SPEED 220
#define HI_SPEED 230
//define Model X pins
#define IN1 12
#define IN2 11
#define IN3 7
#define IN4 8
#define ENA 3        //  ENA pin
#define ENB 6        //  ENB pin
//define steer directing
#define SHARP_RIGHT 120       // steeling to front (120 degree)
#define RIGHT 105        // steeling to front (105 degree)
#define SLIGHT_RIGHT 98
#define FRONT 90        // steering to front (90 degree)
#define SLIGHT_LEFT 82
#define LEFT 75        // steering to right (75 degree)
#define SHARP_LEFT 60        // steering to sharp right (60 degree)

#define SERVO_PIN    9  //servo connect to D3
 
Servo head;
/*motor control*/
void go_Advance(int speed)  //Forward
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW); 
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4,LOW);
   analogWrite(ENA,speed);
   analogWrite(ENB,speed);
}
 
void go_Back(int speed)  //Forward
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,HIGH); 
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,HIGH);
 
  analogWrite(ENA,speed);
  analogWrite(ENB,speed);
}

void turn_left()  //Forward
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW); 
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4,LOW);
 
  analogWrite(ENA,HI_SPEED);
  analogWrite(ENB,SPEED);
}
void turn_right()  //Forward
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW); 
  digitalWrite(IN3, HIGH);
  digitalWrite(IN4,LOW);
 
  analogWrite(ENA,SPEED);
  analogWrite(ENB,HI_SPEED);
}
void steer(int angle)
{

  head.write(angle);

}
 
void stop_Stop()    //Stop
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3, LOW);
  digitalWrite(IN4,LOW);
   
  analogWrite(ENA,0);
  analogWrite(ENB,0);
}

#define LFSensor_0 A0
#define LFSensor_1 A1
#define LFSensor_2 A2
#define LFSensor_3 A3
#define LFSensor_4 A4
char sensor[5];
String read_sensor_values()
{   int sensorvalue=32;
  sensor[0]= !digitalRead(LFSensor_0);
 
  sensor[1]=!digitalRead(LFSensor_1);
 
  sensor[2]=!digitalRead(LFSensor_2);
 
  sensor[3]=!digitalRead(LFSensor_3);
 
  sensor[4]=!digitalRead(LFSensor_4);
  sensorvalue +=sensor[4]*16+sensor[3]*8+sensor[2]*4+sensor[1]*2+sensor[0];
 
  String senstr= String(sensorvalue,BIN);
 
  return senstr.substring(1,6);
}


void setup() {

 pinMode(ENA, OUTPUT); 
 pinMode(ENB, OUTPUT); 
 pinMode(IN1, OUTPUT); 
 pinMode(IN2, OUTPUT); 
 pinMode(IN3, OUTPUT); 
 pinMode(IN4, OUTPUT); 
 
 pinMode(LFSensor_0,INPUT);
 pinMode(LFSensor_1,INPUT);
 pinMode(LFSensor_2,INPUT);
 pinMode(LFSensor_3,INPUT);
 pinMode(LFSensor_4,INPUT); 
 
 Serial.begin(9600);
 head.attach(SERVO_PIN);
  steer(FRONT);
  /*
 go_Advance(HI_SPEED);
 delay(1000);
  go_Back(HI_SPEED);
 delay(1000);
   steer(LEFT);
   go_Advance(HI_SPEED);
    delay(1000);
   steer(RIGHT);
   go_Advance(HI_SPEED);
    delay(1000);
  steer(SHARP_LEFT);
   turn_left(HI_SPEED);
    delay(1000); 
  steer(SHARP_RIGHT);
   turn_right(HI_SPEED);
   delay(1000);
   steer(FRONT);
   */
stop_Stop();
     
}

void auto_tracking(){
  String senstr= read_sensor_values();
 
  if ( senstr=="10000" || senstr=="01000" || senstr=="11000")
   {
      Serial.println("Sharp Left");
      steer(SHARP_LEFT);
      go_Advance(SPEED);
       delay(DELAY_TIME);
      stop_Stop();
      delay(SHORT_DELAY_TIME);
   }
   
  if ( senstr=="11100" || senstr=="10100" )
  {
      steer(LEFT);
      go_Advance(SPEED);
     delay(DELAY_TIME);
     stop_Stop();
     delay(SHORT_DELAY_TIME);
  }
  if ( senstr=="01100" ||  senstr=="11110"  || senstr=="10010"  || senstr=="10110"  || senstr=="11010")
  {
      steer(SLIGHT_LEFT);
      go_Advance(SPEED);
       delay(DELAY_TIME);
     stop_Stop();
     delay(SHORT_DELAY_TIME);
  }
 if (senstr=="01110" || senstr=="01010" || senstr=="00100"  || senstr=="10001"  || senstr=="10101"  || senstr=="10011" || senstr=="11101" || senstr=="10111" || senstr=="11011"  || senstr=="11001")
  {
      steer(FRONT);
      go_Advance(SPEED);
     delay(DELAY_TIME);
       stop_Stop();
     delay(SHORT_DELAY_TIME);
  }
 if ( senstr=="00110" || senstr=="01111" || senstr=="01001" || senstr=="01011" || senstr=="01101")
  {
      steer(SLIGHT_RIGHT);
      go_Advance(SPEED);
     delay(DELAY_TIME);
      stop_Stop();
     delay(SHORT_DELAY_TIME);
  }
 if (senstr=="00111" || senstr=="00101" )
  {   
      steer(RIGHT);
      go_Advance(SPEED);
    delay(DELAY_TIME);
     stop_Stop();
     delay(SHORT_DELAY_TIME);
  }
 if (senstr=="00001" || senstr=="00010" || senstr=="00011")
 {
   Serial.println("Shift to Right");
      steer(SHARP_RIGHT);
      go_Advance(SPEED);
      delay(DELAY_TIME);
      stop_Stop();  
      delay(SHORT_DELAY_TIME);
 }
  if (  senstr=="00000"){
      go_Advance(SPEED);
    
  }
 if (  senstr=="11111")
 {
   Serial.println("Sharp Right U Turn");
    stop_Stop();  
 
 }

}
void loop() {
  auto_tracking();
}
